Index: src/isdn/Q931ie.c
===================================================================
--- src/isdn/Q931ie.c	(revision 495)
+++ src/isdn/Q931ie.c	(working copy)
@@ -71,8 +71,7 @@
 #define Q931MoreIE() (Octet+Off - 2 < IESize)
 
 #define Q931IESizeTest(x)   {\
-                            if(Octet+Off-2 != IESize)\
-                            {\
+		if(Octet+Off-2 != IESize) {\
                                 Q931SetError(pTrunk,x, Octet, Off);\
                                 return x;\
                             }\
@@ -135,9 +134,10 @@
     L3INT IESize;
     *pIE=0;
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Decoding Bearer Capability IE\n");
+
     /* Octet 1 */
-    pie->IEId        = IBuf[Octet];
-    Octet ++;
+	pie->IEId = IBuf[Octet++];
 
     /* Octet 2 */
     IESize = IBuf[Octet ++]; 
@@ -176,16 +176,15 @@
 
         if(IsQ931Ext(IBuf[Octet+Off-1]))
         {
-            if(((pie->ITC == 0x08) && (pie->UIL1Prot == 0x01 || pie->UIL1Prot == 0x08))
-            || ((pie->ITC == 0x10) && (pie->UIL1Prot == 0x02 || pie->UIL1Prot == 0x03)))
+			if(((pie->ITC == 0x08) && (pie->UIL1Prot == 0x01 || pie->UIL1Prot == 0x08)) ||
+			   ((pie->ITC == 0x10) && (pie->UIL1Prot == 0x02 || pie->UIL1Prot == 0x03)))
             {
                 pie->SyncAsync   = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
                 pie->Negot       = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 5);
                 pie->UserRate    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
                 Off ++;
             }
-            else
-            {
+			else {
                 /* We have detected bit 8 = 0, but no setting that require the  */
                 /* additional octets ???                                        */
                 Q931SetError(pTrunk, Q931E_BEARERCAP, 5,Off);
@@ -214,11 +213,9 @@
                     pie->InBandNeg   = ieGetOctet((IBuf[Octet+Off] & 0x02) >> 1);
                     Off++;
                 }
-                else
-                {
+				else {
                     Q931SetError(pTrunk,Q931E_BEARERCAP, 5,Off);
                     return Q931E_BEARERCAP;
-
                 }
 
                 /* Octet 5c */
@@ -275,11 +270,9 @@
                     Off++;
                 }
             }
-            else
-            {
+			else {
                 Q931SetError(pTrunk,Q931E_BEARERCAP, 7, Off);
                 return Q931E_BEARERCAP;
-
             }
         }
     }
@@ -318,73 +311,74 @@
     L3INT Beg=*Octet;/* remember current offset */
     L3INT li;
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Encoding Bearer Capability IE\n");
+
     OBuf[(*Octet)++] = Q931ie_BEARER_CAPABILITY ;
     li=(*Octet)++;    /* remember length position */
 
     /* Octet 3 - Coding standard / Information transfer capability */
-    OBuf[(*Octet)++] = 0x80 | (pIE->CodStand<<5) | (pIE->ITC & 0x1f);
+	OBuf[(*Octet)++] = 0x80 | ((pIE->CodStand << 5) & 0x60) | (pIE->ITC & 0x1f);
 
     /* Octet 4 - Transfer mode / Information transfer rate */
-	OBuf[(*Octet)++] = 0x80 | (pIE->TransMode<<5) | (pIE->ITR & 0x1f);
+	OBuf[(*Octet)++] = 0x80 | ((pIE->TransMode << 5) & 0x60) | (pIE->ITR & 0x1f);
+
     if(pIE->ITR == 0x18)
     {
         /* Octet 4.1 - Rate Multiplier */
-        OBuf[(*Octet)++] = 0x80 | pIE->RateMul;
+		OBuf[(*Octet)++] = 0x80 | (pIE->RateMul & 0x7f);
     }
 
     /* Octet 5 - Layer 1 Ident / User information layer 1 protocol*/
     if(pIE->Layer1Ident == 0x01)
     {
-        if(((pIE->ITC == 0x08) && (pIE->UIL1Prot == 0x01 || pIE->UIL1Prot == 0x08))
-        || ((pIE->ITC == 0x10) && (pIE->UIL1Prot == 0x02 || pIE->UIL1Prot == 0x03)))
+		if(((pIE->ITC == 0x08) && (pIE->UIL1Prot == 0x01 || pIE->UIL1Prot == 0x08)) ||
+		   ((pIE->ITC == 0x10) && (pIE->UIL1Prot == 0x02 || pIE->UIL1Prot == 0x03)))
         {
-            OBuf[(*Octet)++] = 0x00 | (pIE->Layer1Ident<<5) | (pIE->UIL1Prot & 0x15);
+			OBuf[(*Octet)++] = 0x00 | ((pIE->Layer1Ident << 5) & 0x60) | (pIE->UIL1Prot & 0x15);
             
             /* Octet 5a - SyncAsync/Negot/UserRate */
-            OBuf[(*Octet)++] = 0x00 | (pIE->SyncAsync<<6) | (pIE->Negot<<5) | (pIE->UserRate&0x1f);
+			OBuf[(*Octet)++] = 0x00 | ((pIE->SyncAsync << 6) & 0x40) | ((pIE->Negot << 5) & 0x20) | (pIE->UserRate & 0x1f);
 
             /* Octet 5b - one of two types */
             if(pIE->UIL1Prot == 0x01) /* ITU V.110, I.460 and X.30           */
             {
                 /* Octet 5b - Intermed rate/ Nic on Tx/Nix on Rx/FlowCtlTx/FlowCtlRx */
                 OBuf[(*Octet)++] = 0x00 
-                                | (pIE->InterRate<<6)
-                                | (pIE->NIConTx << 4)
-                                | (pIE->NIConRx << 3)
-                                | (pIE->FlowCtlTx << 2)
-                                | (pIE->FlowCtlRx << 1);
+						| ((pIE->InterRate << 6) & 0x60)
+						| ((pIE->NIConTx   << 4) & 0x10)
+						| ((pIE->NIConRx   << 3) & 0x08)
+						| ((pIE->FlowCtlTx << 2) & 0x04)
+						| ((pIE->FlowCtlRx << 1) & 0x02);
             }
             else if(pIE->UIL1Prot == 0x08) /* ITU V.120                      */
             {
                 /* Octet 5b - HDR/Multiframe/Mode/LLINegot/Assignor/Inbandneg*/
                 OBuf[(*Octet)++] = 0x00
-                                | (pIE->InterRate << 6)
-                                | (pIE->MultiFrame << 5)
-                                | (pIE->Mode << 4)
-                                | (pIE->LLInegot << 3)
-                                | (pIE->Assignor << 2)
-                                | (pIE->InBandNeg << 1);
+						| ((pIE->InterRate  << 6) & 0x60)
+						| ((pIE->MultiFrame << 5) & 0x20)
+						| ((pIE->Mode       << 4) & 0x10)
+						| ((pIE->LLInegot   << 3) & 0x08)
+						| ((pIE->Assignor   << 2) & 0x04)
+						| ((pIE->InBandNeg  << 1) & 0x02);
             }
 
             /* Octet 5c - NumStopBits/NumStartBits/Parity                    */
             OBuf[(*Octet)++] = 0x00 
-                            | (pIE->NumStopBits << 5 )
-                            | (pIE->NumDataBits << 3 )
-                            | (pIE->Parity);
+					| ((pIE->NumStopBits << 5) & 0x60)
+					| ((pIE->NumDataBits << 3) & 0x18)
+					| (pIE->Parity & 0x07);
 
             /* Octet 5d - Duplex Mode/Modem Type */
-            OBuf[(*Octet)++] = 0x80 | (pIE->DuplexMode<<6) | (pIE->ModemType);
+			OBuf[(*Octet)++] = 0x80 | ((pIE->DuplexMode << 6) & 0x40) | (pIE->ModemType & 0x3f);
         }
-        else
-        {
-            OBuf[(*Octet)++] = 0x80 | (pIE->Layer1Ident<<5) | (pIE->UIL1Prot & 0x1F);
+		else {
+			OBuf[(*Octet)++] = 0x80 | ((pIE->Layer1Ident << 5) & 0x60) | (pIE->UIL1Prot & 0x1f);
         }
     }
 
     /* Octet 6 - Layer2Ident/User information layer 2 prtocol */
-    if(pIE->Layer2Ident == 0x02)
-    {
-        OBuf[(*Octet)++] = 0x80 | (pIE->Layer2Ident<<5) | (pIE->UIL2Prot);
+	if(pIE->Layer2Ident == 0x02) {
+		OBuf[(*Octet)++] = 0x80 | ((pIE->Layer2Ident << 5) & 0x60) | (pIE->UIL2Prot & 0x1f);
     }
 
     /* Octet 7 - Layer 3 Ident/ User information layer 3 protocol */
@@ -392,17 +386,16 @@
     {
         if(pIE->UIL3Prot == 0x0c)
         {
-            OBuf[(*Octet)++] = 0x00 | (pIE->Layer3Ident<<5) | (pIE->UIL3Prot);
+			OBuf[(*Octet)++] = 0x00 | ((pIE->Layer3Ident << 5) & 0x60) | (pIE->UIL3Prot & 0x1f);
 
             /* Octet 7a - Additional information layer 3 msb */
-            OBuf[(*Octet)++] = 0x00 | (pIE->AL3Info1);
+			OBuf[(*Octet)++] = 0x00 | (pIE->AL3Info1 & 0x0f);
 
             /* Octet 7b - Additional information layer 3 lsb */
-            OBuf[(*Octet)++] = 0x80 | (pIE->AL3Info2);
+			OBuf[(*Octet)++] = 0x80 | (pIE->AL3Info2 & 0x0f);
         }
-        else
-        {
-            OBuf[(*Octet)++] = 0x80 | (pIE->Layer3Ident<<5) | (pIE->UIL3Prot);
+		else {
+			OBuf[(*Octet)++] = 0x80 | ((pIE->Layer3Ident << 5) & 0x60) | (pIE->UIL3Prot & 0x1f);
         }
     }
 
@@ -1160,9 +1154,10 @@
 //18 04 e1 80 83 01
     *pIE=0;
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Decoding Channel ID IE\n");
+
     /* Octet 1 */
-    pie->IEId        = IBuf[Octet];
-    Octet ++;
+	pie->IEId = IBuf[Octet++];
 
     /* Octet 2 */
     IESize = IBuf[Octet ++]; 
@@ -1174,11 +1169,9 @@
     pie->DChanInd        = (IBuf[Octet] >> 2) & 0x01;
     pie->InfoChanSel    = IBuf[Octet] & 0x03;
 
-    Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-    Octet++;
+	Off = Q931ReadExt(&IBuf[Octet++], Off);
 
     /* Octet 3.1 */
-
     if(pie->IntIDPresent)
     {
         pie->InterfaceID    = IBuf[Octet+Off] & 0x7f;
@@ -1191,7 +1184,7 @@
         Off++;
     }
 
-    if (Octet + Off -2 != IESize) {
+	if ((Octet + Off - 2) != IESize) {
         /* Octet 3.2 */
         if(pie->IntType == 1)        /* PRI etc */
         {
@@ -1198,13 +1191,12 @@
             pie->CodStand    = (IBuf[Octet + Off] >> 5) & 0x03;
             pie->NumMap        = (IBuf[Octet + Off] >> 4) & 0x01;
             pie->ChanMapType= IBuf[Octet + Off] & 0x0f;
-
             Off ++;
 
-
             /* Octet 3.3 */
-            /* Temp fix. Assume B channel. H channels not supported */
+			/* TODO: Temp fix. Assume B channel. H channels not supported */
             pie->ChanSlot = IBuf[Octet+Off] & 0x7f;
+
 			/* Some dialects don't follow the extension coding properly for this, but this should be safe for all */
 			if (Octet + Off -1 != IESize) {
 				Off = Q931ReadExt(&IBuf[Octet+Off], Off);
@@ -1221,6 +1213,39 @@
     *OOff = (*OOff) + sizeof(Q931ie_BearerCap);
     pie->Size = sizeof(Q931ie_BearerCap);
 
+	if(pTrunk->loglevel == Q931_LOG_DEBUG)
+	{
+		const char *iface;
+		char tmp[100] = "";
+
+		if(!pie->IntType) {
+			switch(pie->InfoChanSel) {
+			case 0x0:
+				iface = "None";
+				break;
+			case 0x1:
+				iface = "B1";
+				break;
+			case 0x2:
+				iface = "B2";
+				break;
+			default:
+				iface = "Any Channel";
+			}
+
+			snprintf(tmp, sizeof(tmp)-1, "InfoChanSel: %d (%s)", pie->InfoChanSel, iface);
+		}
+
+		Q931Log(pTrunk, Q931_LOG_DEBUG,
+			"\n\n-------------------------- Q.931 Channel ID ------------------------\n"
+			"    Pref/Excl: %s, Interface Type: %s\n"
+			"    %s\n"
+			"--------------------------------------------------------------------\n\n",
+			((pie->PrefExcl) ? "Preferred" : "Exclusive"),
+			((pie->IntType) ? "PRI/Other" : "BRI"),
+			tmp);
+	}
+
     return Q931E_NO_ERROR;
 }
 
@@ -1247,15 +1272,15 @@
 
     /* Octet 3 flags & BRI chan # */
     OBuf[(*Octet)++] = 0x80 
-                    | (pIE->IntIDPresent << 6) 
-                    | (pIE->IntType<<5)
-                    | (pIE->PrefExcl<<3) 
-                    | pIE->InfoChanSel;
+			| ((pIE->IntIDPresent << 6) & 0x40)
+			| ((pIE->IntType << 5) & 0x20)
+			| ((pIE->PrefExcl << 3) & 0x08)
+			|  (pIE->InfoChanSel & 0x03);
 
     /* Octet 3.1 - Interface Identifier */
     if(pIE->IntIDPresent)
     {
-        OBuf[(*Octet)++] = 0x80 | pIE->InterfaceID;
+		OBuf[(*Octet)++] = 0x80 | (pIE->InterfaceID & 0x7f);
     }
     else
     {
@@ -1263,12 +1288,21 @@
         if(pIE->IntType == 1)
         {
             OBuf[(*Octet)++]  = 0x80
-                            | (pIE->CodStand << 5)
-                            | (pIE->NumMap << 4)
-                            | pIE->ChanMapType;
-
-            /* Octet 3.2 Channel number/slot map */
-            OBuf[(*Octet)++] = 0x80 | pIE->ChanSlot;
+					| ((pIE->CodStand << 5) & 0x60)
+					| ((pIE->NumMap << 4) & 0x10)
+					|  (pIE->ChanMapType & 0x0f);		/* TODO: support all possible channel map types */
+
+			/* Octet 3.3 Channel number */
+			switch(pIE->ChanMapType) {
+			case 0x6:	/* Slot map: H0 Channel Units */	/* unsupported, Octets 3.3.1 - 3.3.3 */
+				return Q931E_CHANID;
+
+			case 0x8:	/* Slot map: H11 Channel Units */
+			case 0x9:	/* Slot map: H12 Channel Units */
+			default:	/* Channel number */
+				OBuf[(*Octet)++] = 0x80 | (pIE->ChanSlot & 0x7f);
+				break;
+			}
         }
     }
 
@@ -1302,21 +1336,18 @@
 *****************************************************************************/
 L3USHORT Q931Uie_CRV(Q931_TrunkInfo_t *pTrunk, L3UCHAR *IBuf, L3UCHAR *OBuf, L3INT *IOff, L3INT *OOff)
 {
+    L3USHORT CRV = 0;
     L3INT Octet = *IOff;
-    L3INT l = IBuf[Octet]; 
-    L3USHORT CRV;
-    Octet++; /*Octet 2 is length indicator */
+    L3INT l = IBuf[Octet++]; 
 
     if(l == 1) /* One octet CRV */
     {
-        CRV = IBuf[Octet] & 0x7F;
-        Octet++;
+        CRV = IBuf[Octet++] & 0x7F;
     }
     else if(l==2) /* two octet CRV */
     {
-        CRV = (IBuf[Octet] & 0x7f) << 8;
-        CRV = CRV + IBuf[Octet+1];
-        Octet += 2;
+        CRV  = (IBuf[Octet++] & 0x7f) << 8;
+        CRV |=  IBuf[Octet++];
     }
     else
     {
@@ -1326,6 +1357,8 @@
         Octet+=l;
     }
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Call reference Value: %d (%#x)\n", CRV);
+
     *IOff = Octet;
     return CRV;
 }
@@ -1354,50 +1387,49 @@
     L3INT Off = 0;
     L3INT Octet = 0;
     L3INT IESize=0;
-
     *pIE=0;
 
-    pie->IEId        = IBuf[Octet];
-    IESize = IBuf[Octet ++];
+	/* Octet 1: ID */
+	pie->IEId  = IBuf[Octet++];
     
-    /* Octet 2 */
+	/* Octet 2: Size */
     IESize = IBuf[Octet ++]; 
 
-    /* Octet 3 - Year */
+	/* Octet 3: Year */
     pie->Year = IBuf[Octet++];
 
-    /* Octet 4 - Month */
+	/* Octet 4: Month */
     pie->Month = IBuf[Octet++];
 
-    /* Octet 5 - Day */
+	/* Octet 5: Day */
     pie->Day = IBuf[Octet++];
 
     /*******************************************************************
-        The remaining part of the IE are optioinal, but only the length 
+		The remaining part of the IE are optional, but only the length 
         can now tell us wherever these fields are present or not
     ********************************************************************/
     pie->Format=0;
 
     /* Octet 6 - Hour (optional)*/
-    if(IESize >= 6)
+	if(IESize >= 4)
     {
         pie->Format = 1;
         pie->Hour = IBuf[Octet++];
+	}
 
         /* Octet 7 - Minute (optional)*/
-        if(IESize >= 7)
+	if(IESize >= 5)
         {
             pie->Format = 2;
             pie->Minute = IBuf[Octet++];
+	}
 
             /* Octet 8 - Second (optional)*/
-            if(IESize >= 8)
+	if(IESize >= 6)
             {
                 pie->Format = 3;
                 pie->Second = IBuf[Octet++];
             }
-        }
-    }
 
     Q931IESizeTest(Q931E_DATETIME);
 
@@ -1434,6 +1466,8 @@
     OBuf[(*Octet)++] = pIE->Year;
     OBuf[(*Octet)++] = pIE->Month;
     OBuf[(*Octet)++] = pIE->Day;
+
+	/* optional fields */
     if(pIE->Format >= 1)
     {
         OBuf[(*Octet)++] = pIE->Hour;
@@ -1475,12 +1509,9 @@
     L3INT Octet = 0;
     L3INT IESize;
     L3INT x;
-
     *pIE=0;
 
-    pie->IEId        = IBuf[Octet];
-    Octet ++;
-
+	pie->IEId = IBuf[Octet++];
     IESize = IBuf[Octet ++]; 
 
     for(x=0; x<IESize; x++)
@@ -1634,7 +1665,7 @@
     li=(*Octet)++;
 
     /* Octet 3 */
-    OBuf[(*Octet)++] = 0x80 | (pIE->CodStand << 5) | (pIE->Interpret << 2) | pIE->PresMeth;
+    OBuf[(*Octet)++] = 0x80 | ((pIE->CodStand << 5) & 0x60) | ((pIE->Interpret << 2) & 0x1c) | (pIE->PresMeth & 0x03);
 
     /* Octet 4 */
     OBuf[(*Octet)++] = pIE->HLCharID;
@@ -1642,11 +1673,11 @@
     /* Octet 4a */
     if(pIE->HLCharID == 0x5e || pIE->HLCharID == 0x5f)
     {
-        OBuf[(*Octet)++] = 0x80 | pIE->EHLCharID;
+        OBuf[(*Octet)++] = 0x80 | (pIE->EHLCharID & 0x7f);
     }
     else if( pIE->HLCharID >= 0xc3 && pIE->HLCharID <= 0xcf)
     {
-        OBuf[(*Octet)++] = 0x80 | pIE->EVideoTlfCharID;
+        OBuf[(*Octet)++] = 0x80 | (pIE->EVideoTlfCharID & 0x7f);
     }
     else
     {
Index: src/isdn/DMSStateTE.c
===================================================================
--- src/isdn/DMSStateTE.c	(revision 495)
+++ src/isdn/DMSStateTE.c	(working copy)
@@ -237,7 +237,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -279,7 +278,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
Index: src/isdn/5ESSmes.c
===================================================================
--- src/isdn/5ESSmes.c	(revision 495)
+++ src/isdn/5ESSmes.c	(working copy)
@@ -158,12 +158,7 @@
     L3INT Octet = 0;
 
     /* Q931 Message Header */
-
-    OBuf[Octet++]    = pMes->ProtDisc;          /* Protocol discriminator           */
-    OBuf[Octet++]    = 2;                       /* length is 2 octets               */
-    OBuf[Octet++]    = (L3UCHAR)(pMes->CRV>>8) | (pMes->CRVFlag << 7);    /* msb    */
-    OBuf[Octet++]    = (L3UCHAR)(pMes->CRV);    /* lsb                              */
-    OBuf[Octet++]    = pMes->MesType;           /* message header                   */
+	Q931MesgHeader(pTrunk, pMes, OBuf, *OSize, &Octet);
     
     /* Sending Complete                */
     if(Q931IsIEPresent(pMes->SendComplete))
Index: src/isdn/Q931api.c
===================================================================
--- src/isdn/Q931api.c	(revision 495)
+++ src/isdn/Q931api.c	(working copy)
@@ -74,8 +74,8 @@
 						Q931Dialect_t Dialect,
 						Q931NetUser_t NetUser,
 						Q931_TrunkType_t TrunkType,
-						Q931TxCB_t Q931Tx34CBProc,
-						Q931TxCB_t Q931Tx32CBProc,
+						Q931Tx34CB_t Q931Tx34CBProc,
+						Q931Tx32CB_t Q931Tx32CBProc,
 						Q931ErrorCB_t Q931ErrorCBProc,
 						void *PrivateData32,
 						void *PrivateData34)
@@ -97,6 +97,7 @@
 		break;
 
 	case Q931_TrType_BRI:
+	case Q931_TrType_BRI_PTMP:
 		dchannel = 3;
 		maxchans = 3;
 		break;
@@ -521,9 +522,11 @@
 L3INT Q931ReleaseComplete(Q931_TrunkInfo_t *pTrunk, L3UCHAR *buf)
 {
     Q931mes_Header *ptr = (Q931mes_Header*)&buf[Q931L4HeaderSpace];
+
 	ptr->MesType = Q931mes_RELEASE_COMPLETE;
 	ptr->CRVFlag = !(ptr->CRVFlag);
-	return Q931Tx32(pTrunk,buf,ptr->Size);
+
+	return Q931Tx32Data(pTrunk,buf,ptr->Size);
 }
 
 L3INT Q931AckRestart(Q931_TrunkInfo_t *pTrunk, L3UCHAR *buf)
Index: src/isdn/Q931StateTE.c
===================================================================
--- src/isdn/Q931StateTE.c	(revision 495)
+++ src/isdn/Q931StateTE.c	(working copy)
@@ -227,7 +227,7 @@
     Q931StartTimer(pTrunk, callIndex, 303);
 	if(iFrom == 4)
 	{
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -259,7 +259,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -292,7 +292,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -329,7 +329,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -362,7 +362,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -399,7 +399,14 @@
             return ret;
         pMes->CRV = pTrunk->call[callIndex].CRV;
 
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		/*
+		 * PTMP NT should use DL-UNIT DATA broadcast (?)
+		 */ 
+		if(pTrunk->TrunkType == Q931_TrType_BRI_PTMP && pTrunk->NetUser == Q931_NT)
+			ret = Q931Tx32UnitData(pTrunk,buf,pMes->Size);
+		else
+			ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
+
         if(ret)
             return ret;
 
@@ -475,7 +480,7 @@
     Q931StartTimer(pTrunk, callIndex, 303);
 	if(iFrom == 4)
 	{
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -504,7 +509,7 @@
         pMes->CRV = pTrunk->call[callIndex].CRV;
 
         /* Send RESUME to network */
-        ret=Q931Tx32(pTrunk,buf, pMes->Size);
+		ret=Q931Tx32Data(pTrunk,buf, pMes->Size);
         if(ret != Q931E_NO_ERROR)
             return ret;
 
@@ -544,7 +549,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -577,7 +582,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -610,7 +615,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -643,7 +648,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -676,7 +681,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -709,7 +714,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -742,7 +747,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -765,7 +770,7 @@
     L3INT ret = Q931E_NO_ERROR;
     if(iFrom == 4) {
 		/* TODO Add proc here*/
-		ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	} else if(state == Q931_U0 && iFrom == 2) {
 		Q931Tx34(pTrunk,buf,pMes->Size);
         ret = Q931ReleaseComplete(pTrunk, buf);
@@ -838,7 +842,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -877,7 +881,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -910,7 +914,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -943,7 +947,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -976,7 +980,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1009,7 +1013,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1042,7 +1046,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1075,7 +1079,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1112,7 +1116,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1145,7 +1149,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1178,7 +1182,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1211,7 +1215,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1244,7 +1248,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1277,7 +1281,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1310,7 +1314,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -1343,7 +1347,7 @@
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+		ret = Q931Tx32Data(pTrunk,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
Index: src/isdn/DMSmes.c
===================================================================
--- src/isdn/DMSmes.c	(revision 495)
+++ src/isdn/DMSmes.c	(working copy)
@@ -155,12 +155,7 @@
 	L3INT Octet = 0;
 
 	/* Q931 Message Header */
-
-	OBuf[Octet++]	= pMes->ProtDisc;		/* Protocol discriminator		*/
-	OBuf[Octet++]	= 2;					/* length is 2 octets			*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV>>8) | (pMes->CRVFlag << 7);	/* msb						*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV);	/* lsb							*/
-	OBuf[Octet++]	= pMes->MesType;		/* message header				*/
+	Q931MesgHeader(pTrunk, pMes, OBuf, *OSize, &Octet);
 	
 	/* Sending Complete				*/
 	if(Q931IsIEPresent(pMes->SendComplete))
